Index: CKEditor/branches/features/paste/_samples/php/advanced.php
===================================================================
--- CKEditor/branches/features/paste/_samples/php/advanced.php	(revision 4743)
+++ CKEditor/branches/features/paste/_samples/php/advanced.php	(revision 4743)
@@ -0,0 +1,91 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<!--
+Copyright (c) 2003-2009, CKSource - Frederico Knabben. All rights reserved.
+For licensing, see LICENSE.html or http://ckeditor.com/license
+-->
+<html xmlns="http://www.w3.org/1999/xhtml">
+<head>
+	<title>Sample - CKEditor</title>
+	<meta content="text/html; charset=utf-8" http-equiv="content-type"/>
+	<link href="../sample.css" rel="stylesheet" type="text/css"/>
+</head>
+<body>
+	<h1>
+		CKEditor Sample
+	</h1>
+	<!-- This <div> holds alert messages to be display in the sample page. -->
+	<div id="alerts">
+		<noscript>
+			<p>
+				<strong>CKEditor requires JavaScript to run</strong>. In a browser with no JavaScript
+				support, like yours, you should still see the contents (HTML data) and you should
+				be able to edit it normally, without a rich editor interface.
+			</p>
+		</noscript>
+	</div>
+	<!-- This <fieldset> holds the HTML that you will usually find in your pages. -->
+	<fieldset title="Output">
+		<legend>Output</legend>
+		<form action="../sample_posteddata.php" method="post">
+			<p>
+				<label>Editor 1:</label><br/>
+			</p>
+<?php
+// Include CKEditor class.
+include("../../ckeditor.php");
+
+// Create class instance. 
+$CKEditor = new CKEditor();
+
+// Do not print the code directly to the browser, return it instead
+$CKEditor->returnOutput = true;
+
+// Path to CKEditor directory, ideally instead of relative dir, use an absolute path:
+//   $CKEditor->basePath = '/ckeditor/'
+// If not set, CKEditor will try to detect the correct path.
+$CKEditor->basePath = '../../';
+
+// Set global configuration (will be used by all instances of CKEditor).
+$CKEditor->config['width'] = 600;
+
+// Change default textarea attributes
+$CKEditor->textareaAttributes = array("cols" => 80, "rows" => 10);
+
+// The initial value to be displayed in the editor.
+$initialValue = '<p>This is some <strong>sample text</strong>. You are using <a href="http://ckeditor.com/">CKEditor</a>.</p>';
+
+// Create first instance.
+$code = $CKEditor->editor("editor1", $initialValue);
+
+echo $code;
+?>
+			<p>
+				<label>Editor 2:</label><br/>
+			</p>
+<?php
+// Configuration that will be used only by the second editor.
+$config['toolbar'] = array(
+	array( 'Source', '-', 'Bold', 'Italic', 'Underline', 'Strike' ),
+	array( 'Image', 'Link', 'Unlink', 'Anchor' )
+);
+
+$config['skin'] = 'v2';
+
+// Create second instance.
+echo $CKEditor->editor("editor2", $initialValue, $config);
+?>
+				<input type="submit" value="Submit"/>
+			</p>
+		</form>
+	</fieldset>
+	<div id="footer">
+		<hr/>
+		<p>
+			CKEditor - The text editor for Internet - <a href="http://ckeditor.com/" shape="rect">http://ckeditor.com</a>
+		</p>
+		<p id="copy">
+			Copyright © 2003-2009, <a href="http://cksource.com/" shape="rect">CKSource</a> - Frederico Knabben. All rights reserved.
+		</p>
+	</div>
+</body>
+</html>
Index: CKEditor/branches/features/paste/_samples/php/events.php
===================================================================
--- CKEditor/branches/features/paste/_samples/php/events.php	(revision 4743)
+++ CKEditor/branches/features/paste/_samples/php/events.php	(revision 4743)
@@ -0,0 +1,128 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<!--
+Copyright (c) 2003-2009, CKSource - Frederico Knabben. All rights reserved.
+For licensing, see LICENSE.html or http://ckeditor.com/license
+-->
+<html xmlns="http://www.w3.org/1999/xhtml">
+<head>
+	<title>Sample - CKEditor</title>
+	<meta content="text/html; charset=utf-8" http-equiv="content-type"/>
+	<link href="../sample.css" rel="stylesheet" type="text/css"/>
+</head>
+<body>
+	<h1>
+		CKEditor Sample
+	</h1>
+	<!-- This <div> holds alert messages to be display in the sample page. -->
+	<div id="alerts">
+		<noscript>
+			<p>
+				<strong>CKEditor requires JavaScript to run</strong>. In a browser with no JavaScript
+				support, like yours, you should still see the contents (HTML data) and you should
+				be able to edit it normally, without a rich editor interface.
+			</p>
+		</noscript>
+	</div>
+	<!-- This <fieldset> holds the HTML that you will usually find in your pages. -->
+	<fieldset title="Output">
+		<legend>Output</legend>
+		<form action="../sample_posteddata.php" method="post">
+			<p>
+				<label>Editor 1:</label><br/>
+			</p>
+<?php
+
+/**
+ * Adds global event, will hide "Target" tab in Link dialog in all instances.
+ */
+function CKEditorHideLinkTargetTab(&$CKEditor) {
+
+	$function = 'function (ev) {
+		// Take the dialog name and its definition from the event data
+		var dialogName = ev.data.name;
+		var dialogDefinition = ev.data.definition;
+
+		// Check if the definition is from the Link dialog.
+		if ( dialogName == "link" )
+			dialogDefinition.removeContents("target")
+	}';
+
+	$CKEditor->addGlobalEventHandler('dialogDefinition', $function);
+}
+
+/**
+ * Adds global event, will notify about opened dialog.
+ */
+function CKEditorNotifyAboutOpenedDialog(&$CKEditor) {
+	$function = 'function (evt) {
+		alert("Loading dialog: " + evt.data.name);
+	}';
+
+	$CKEditor->addGlobalEventHandler('dialogDefinition', $function);
+}
+
+// Include CKEditor class.
+include("../../ckeditor.php");
+
+// Create class instance. 
+$CKEditor = new CKEditor();
+
+// Set configuration option for all editors.
+$CKEditor->config['width'] = 750;
+
+// Path to CKEditor directory, ideally instead of relative dir, use an absolute path:
+//   $CKEditor->basePath = '/ckeditor/'
+// If not set, CKEditor will try to detect the correct path.
+$CKEditor->basePath = '../../';
+
+// The initial value to be displayed in the editor.
+$initialValue = '<p>This is some <strong>sample text</strong>. You are using <a href="http://ckeditor.com/">CKEditor</a>.</p>';
+
+// Event that will be handled only by the first editor.
+$CKEditor->addEventHandler('instanceReady', 'function (evt) {
+	alert("Loaded editor: " + evt.editor.name);
+}');
+
+// Create first instance.
+$CKEditor->editor("editor1", $initialValue);
+
+// Clear event handlers, instances that will be created later will not have
+// the 'instanceReady' listener defined a couple of lines above.
+$CKEditor->clearEventHandlers();
+?>
+			<p>
+				<label>Editor 2:</label><br/>
+			</p>
+<?php
+// Configuration that will be used only by the second editor.
+$config['width'] = '600';
+$config['toolbar'] = 'Basic';
+
+// Add some global event handlers (for all editors).
+CKEditorHideLinkTargetTab($CKEditor);
+CKEditorNotifyAboutOpenedDialog($CKEditor);
+
+// Event that will be handled only by the second editor.
+// Instead of calling addEventHandler(), events may be passed as an argument.
+$events['instanceReady'] = 'function (evt) {
+	alert("Loaded second editor: " + evt.editor.name);
+}';
+
+// Create second instance.
+$CKEditor->editor("editor2", $initialValue, $config, $events);
+?>
+				<input type="submit" value="Submit"/>
+			</p>
+		</form>
+	</fieldset>
+	<div id="footer">
+		<hr/>
+		<p>
+			CKEditor - The text editor for Internet - <a href="http://ckeditor.com/" shape="rect">http://ckeditor.com</a>
+		</p>
+		<p id="copy">
+			Copyright © 2003-2009, <a href="http://cksource.com/" shape="rect">CKSource</a> - Frederico Knabben. All rights reserved.
+		</p>
+	</div>
+</body>
+</html>
Index: CKEditor/branches/features/paste/_samples/php/replace.php
===================================================================
--- CKEditor/branches/features/paste/_samples/php/replace.php	(revision 4743)
+++ CKEditor/branches/features/paste/_samples/php/replace.php	(revision 4743)
@@ -0,0 +1,62 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<!--
+Copyright (c) 2003-2009, CKSource - Frederico Knabben. All rights reserved.
+For licensing, see LICENSE.html or http://ckeditor.com/license
+-->
+<html xmlns="http://www.w3.org/1999/xhtml">
+<head>
+	<title>Sample - CKEditor</title>
+	<meta content="text/html; charset=utf-8" http-equiv="content-type"/>
+	<link href="../sample.css" rel="stylesheet" type="text/css"/>
+</head>
+<body>
+	<h1>
+		CKEditor Sample
+	</h1>
+	<!-- This <div> holds alert messages to be display in the sample page. -->
+	<div id="alerts">
+		<noscript>
+			<p>
+				<strong>CKEditor requires JavaScript to run</strong>. In a browser with no JavaScript
+				support, like yours, you should still see the contents (HTML data) and you should
+				be able to edit it normally, without a rich editor interface.
+			</p>
+		</noscript>
+	</div>
+	<!-- This <fieldset> holds the HTML that you will usually find in your pages. -->
+	<fieldset title="Output">
+		<legend>Output</legend>
+		<form action="../sample_posteddata.php" method="post">
+			<p>
+				<label for="editor1">
+					Editor 1:</label><br/>
+				<textarea cols="80" id="editor1" name="editor1" rows="10">&lt;p&gt;This is some &lt;strong&gt;sample text&lt;/strong&gt;. You are using &lt;a href="http://ckeditor.com/"&gt;CKEditor&lt;/a&gt;.&lt;/p&gt;</textarea>
+			</p>
+			<p>
+				<input type="submit" value="Submit"/>
+			</p>
+		</form>
+	</fieldset>
+	<div id="footer">
+		<hr/>
+		<p>
+			CKEditor - The text editor for Internet - <a href="http://ckeditor.com/" shape="rect">http://ckeditor.com</a>
+		</p>
+		<p id="copy">
+			Copyright © 2003-2009, <a href="http://cksource.com/" shape="rect">CKSource</a> - Frederico Knabben. All rights reserved.
+		</p>
+	</div>
+	<?php
+	// Include CKEditor class.
+	include_once "../../ckeditor.php";
+	// Create class instance.
+	$CKEditor = new CKEditor();
+	// Path to CKEditor directory, ideally instead of relative dir, use an absolute path:
+	//   $CKEditor->basePath = '/ckeditor/'
+	// If not set, CKEditor will try to detect the correct path.
+	$CKEditor->basePath = '../../';
+	// Replace textarea with id (or name) "editor1".
+	$CKEditor->replace("editor1");
+	?>
+</body>
+</html>
Index: CKEditor/branches/features/paste/_samples/php/replaceall.php
===================================================================
--- CKEditor/branches/features/paste/_samples/php/replaceall.php	(revision 4743)
+++ CKEditor/branches/features/paste/_samples/php/replaceall.php	(revision 4743)
@@ -0,0 +1,67 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<!--
+Copyright (c) 2003-2009, CKSource - Frederico Knabben. All rights reserved.
+For licensing, see LICENSE.html or http://ckeditor.com/license
+-->
+<html xmlns="http://www.w3.org/1999/xhtml">
+<head>
+	<title>Sample - CKEditor</title>
+	<meta content="text/html; charset=utf-8" http-equiv="content-type"/>
+	<link href="../sample.css" rel="stylesheet" type="text/css"/>
+</head>
+<body>
+	<h1>
+		CKEditor Sample
+	</h1>
+	<!-- This <div> holds alert messages to be display in the sample page. -->
+	<div id="alerts">
+		<noscript>
+			<p>
+				<strong>CKEditor requires JavaScript to run</strong>. In a browser with no JavaScript
+				support, like yours, you should still see the contents (HTML data) and you should
+				be able to edit it normally, without a rich editor interface.
+			</p>
+		</noscript>
+	</div>
+	<!-- This <fieldset> holds the HTML that you will usually find in your pages. -->
+	<fieldset title="Output">
+		<legend>Output</legend>
+		<form action="../sample_posteddata.php" method="post">
+			<p>
+				<label for="editor1">
+					Editor 1:</label><br/>
+				<textarea cols="80" id="editor1" name="editor1" rows="10">&lt;p&gt;This is some &lt;strong&gt;sample text&lt;/strong&gt;. You are using &lt;a href="http://ckeditor.com/"&gt;CKEditor&lt;/a&gt;.&lt;/p&gt;</textarea>
+			</p>
+			<p>
+				<label for="editor2">
+					Editor 2:</label><br/>
+				<textarea cols="80" id="editor2" name="editor2" rows="10">&lt;p&gt;This is some &lt;strong&gt;sample text&lt;/strong&gt;. You are using &lt;a href="http://ckeditor.com/"&gt;CKEditor&lt;/a&gt;.&lt;/p&gt;</textarea>
+			</p>
+			<p>
+				<input type="submit" value="Submit"/>
+			</p>
+		</form>
+	</fieldset>
+	<div id="footer">
+		<hr/>
+		<p>
+			CKEditor - The text editor for Internet - <a href="http://ckeditor.com/" shape="rect">http://ckeditor.com</a>
+		</p>
+		<p id="copy">
+			Copyright © 2003-2009, <a href="http://cksource.com/" shape="rect">CKSource</a> - Frederico Knabben. All rights reserved.
+		</p>
+	</div>
+	<?php
+	// Include CKEditor class.
+	include("../../ckeditor.php");
+	// Create class instance.
+	$CKEditor = new CKEditor();
+	// Path to CKEditor directory, ideally instead of relative dir, use an absolute path:
+	//   $CKEditor->basePath = '/ckeditor/'
+	// If not set, CKEditor will try to detect the correct path.
+	$CKEditor->basePath = '../../';
+	// Replace all textareas with CKEditor.
+	$CKEditor->replaceAll();
+	?>
+</body>
+</html>
Index: CKEditor/branches/features/paste/_samples/php/standalone.php
===================================================================
--- CKEditor/branches/features/paste/_samples/php/standalone.php	(revision 4743)
+++ CKEditor/branches/features/paste/_samples/php/standalone.php	(revision 4743)
@@ -0,0 +1,63 @@
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+<!--
+Copyright (c) 2003-2009, CKSource - Frederico Knabben. All rights reserved.
+For licensing, see LICENSE.html or http://ckeditor.com/license
+-->
+<html xmlns="http://www.w3.org/1999/xhtml">
+<head>
+	<title>Sample - CKEditor</title>
+	<meta content="text/html; charset=utf-8" http-equiv="content-type"/>
+	<link href="../sample.css" rel="stylesheet" type="text/css"/>
+</head>
+<body>
+	<h1>
+		CKEditor Sample
+	</h1>
+	<!-- This <div> holds alert messages to be display in the sample page. -->
+	<div id="alerts">
+		<noscript>
+			<p>
+				<strong>CKEditor requires JavaScript to run</strong>. In a browser with no JavaScript
+				support, like yours, you should still see the contents (HTML data) and you should
+				be able to edit it normally, without a rich editor interface.
+			</p>
+		</noscript>
+	</div>
+	<!-- This <fieldset> holds the HTML that you will usually find in your pages. -->
+	<fieldset title="Output">
+		<legend>Output</legend>
+		<form action="../sample_posteddata.php" method="post">
+			<p>
+				<label for="editor1">
+					Editor 1:</label><br/>
+			</p>
+			<p>
+			<?php
+				// Include CKEditor class.
+				include_once "../../ckeditor.php";
+				// The initial value to be displayed in the editor.
+				$initialValue = '<p>This is some <strong>sample text</strong>.</p>';
+				// Create class instance.
+				$CKEditor = new CKEditor();
+				// Path to CKEditor directory, ideally instead of relative dir, use an absolute path:
+				//   $CKEditor->basePath = '/ckeditor/'
+				// If not set, CKEditor will try to detect the correct path.
+				$CKEditor->basePath = '../../';
+				// Create textarea element and attach CKEditor to it.
+				$CKEditor->editor("editor1", $initialValue);
+			?>
+				<input type="submit" value="Submit"/>
+			</p>
+		</form>
+	</fieldset>
+	<div id="footer">
+		<hr/>
+		<p>
+			CKEditor - The text editor for Internet - <a href="http://ckeditor.com/" shape="rect">http://ckeditor.com</a>
+		</p>
+		<p id="copy">
+			Copyright © 2003-2009, <a href="http://cksource.com/" shape="rect">CKSource</a> - Frederico Knabben. All rights reserved.
+		</p>
+	</div>
+</body>
+</html>
Index: CKEditor/branches/features/paste/_source/core/dom/element.js
===================================================================
--- CKEditor/branches/features/paste/_source/core/dom/element.js	(revision 4717)
+++ CKEditor/branches/features/paste/_source/core/dom/element.js	(revision 4743)
@@ -432,7 +432,10 @@
 								attrValue = attr.specified ? attr.nodeValue     // For value given by parser.
 															 : this.$.checked;  // For value created via DOM interface.
-							
+
 							return attrValue ? 'checked' : null;
 						}
+
+						case 'hspace':
+							return this.$.hspace;
 
 						case 'style':
@@ -1001,8 +1004,7 @@
 		removeStyle : function( name )
 		{
+			this.setStyle( name, '' );
 			if ( this.$.style.removeAttribute )
 				this.$.style.removeAttribute( CKEDITOR.tools.cssStyleToDomStyle( name ) );
-			else
-				this.setStyle( name, '' );
 
 			if ( !this.$.style.cssText )
Index: CKEditor/branches/features/paste/_source/core/dom/range.js
===================================================================
--- CKEditor/branches/features/paste/_source/core/dom/range.js	(revision 4717)
+++ CKEditor/branches/features/paste/_source/core/dom/range.js	(revision 4743)
@@ -307,4 +307,13 @@
 			    || !CKEDITOR.tools.trim( node.getText() )
 			    || node.getParent().hasAttribute( '_fck_bookmark' );
+	}
+
+	var whitespaceEval = new CKEDITOR.dom.walker.whitespaces(),
+		bookmarkEval = new CKEDITOR.dom.walker.bookmark();
+
+	function nonWhitespaceOrBookmarkEval( node )
+	{
+		// Whitespaces and bookmark nodes are to be ignored.
+		return !whitespaceEval( node ) && !bookmarkEval( node );
 	}
 
@@ -1459,16 +1468,5 @@
 				else
 				{
-					// Extract the contents of the block from the selection point to the end
-					// of its contents.
-					this.setEndAt( startBlock, CKEDITOR.POSITION_BEFORE_END );
-					var documentFragment = this.extractContents();
-
-					// Duplicate the block element after it.
-					endBlock = startBlock.clone( false );
-
-					// Place the extracted contents into the duplicated block.
-					documentFragment.appendTo( endBlock );
-					endBlock.insertAfter( startBlock );
-					this.moveToPosition( startBlock, CKEDITOR.POSITION_AFTER_END );
+					endBlock = this.splitElement( startBlock );
 
 					// In Gecko, the last child node must be a bogus <br>.
@@ -1490,4 +1488,31 @@
 
 		/**
+		 * Branch the specified element from the collapsed range position and
+		 * place the caret between the two result branches.
+		 * Note: The range must be collapsed and been enclosed by this element.
+		 * @param {CKEDITOR.dom.element} element
+		 * @return {CKEDITOR.dom.element} Root element of the new branch after the split.
+		 */
+		splitElement : function( toSplit )
+		{
+			if ( !this.collapsed )
+				return null;
+
+			// Extract the contents of the block from the selection point to the end
+			// of its contents.
+			this.setEndAt( toSplit, CKEDITOR.POSITION_BEFORE_END );
+			var documentFragment = this.extractContents();
+
+			// Duplicate the element after it.
+			var clone = toSplit.clone( false );
+
+			// Place the extracted contents into the duplicated element.
+			documentFragment.appendTo( clone );
+			clone.insertAfter( toSplit );
+			this.moveToPosition( toSplit, CKEDITOR.POSITION_AFTER_END );
+			return clone;
+		},
+
+		/**
 		 * Check whether current range is on the inner edge of the specified element.
 		 * @param {Number} checkType ( CKEDITOR.START | CKEDITOR.END ) The checking side.
@@ -1585,34 +1610,47 @@
 		 * "&lt;p&gt;&lt;b&gt;&lt;i&gt;&lt;/i&gt;&lt;/b&gt; Text&lt;/p&gt;", the start editing point is
 		 * "&lt;p&gt;&lt;b&gt;&lt;i&gt;^&lt;/i&gt;&lt;/b&gt; Text&lt;/p&gt;" (inside &lt;i&gt;).
-		 * @param {CKEDITOR.dom.element} targetElement The element into which
-		 *		look for the editing spot, it should be guaranteed to contains at least one editable position.
-			@param {Boolean} isMoveToEnd Whether move to the end editable position.
+		 * @param {CKEDITOR.dom.element} el The element into which look for the
+		 *		editing spot.
+		 * @param {Boolean} isMoveToEnd Whether move to the end editable position.
 		 */
-		moveToElementEditablePosition: function( targetElement, isMoveToEnd )
-		{
-			var editableElement;
-
-			while ( targetElement && targetElement.type == CKEDITOR.NODE_ELEMENT )
-			{
-				if ( targetElement.isEditable() )
-					editableElement = targetElement;
-				else if ( editableElement )
-					break ;		// If we already found an editable element, stop the loop.
-
-				targetElement = targetElement[ isMoveToEnd? 'getLast' : 'getFirst' ].call( targetElement );
-			}
-
-			if ( editableElement )
-			{
-				// Make sure carot anchor before filler when moving to editable end.
-				var filler = editableElement.isBlockBoundary() && editableElement.getBogus();
-				this.moveToPosition( isMoveToEnd && filler ? filler : editableElement,
-						isMoveToEnd && filler ? CKEDITOR.POSITION_BEFORE_START :
-							isMoveToEnd ? CKEDITOR.POSITION_BEFORE_END :
-							CKEDITOR.POSITION_AFTER_START );
-				return true;
-			}
-			else
-				return false;
+		moveToElementEditablePosition : function( el, isMoveToEnd )
+		{
+			var isEditable;
+
+			while ( el && el.type == CKEDITOR.NODE_ELEMENT )
+			{
+				isEditable = el.isEditable();
+
+				// If an editable element is found, move inside it.
+				if ( isEditable )
+					this.moveToPosition( el, isMoveToEnd ?
+					                         CKEDITOR.POSITION_BEFORE_END :
+					                         CKEDITOR.POSITION_AFTER_START );
+				// Stop immediately if we've found a non editable inline element (e.g <img>).
+				else if ( CKEDITOR.dtd.$inline[ el.getName() ] )
+				{
+					this.moveToPosition( el, isMoveToEnd ?
+					                         CKEDITOR.POSITION_AFTER_END :
+					                         CKEDITOR.POSITION_BEFORE_START );
+					return true;
+				}
+
+				// Non-editable non-inline elements are to be bypassed, getting the next one.
+				if ( CKEDITOR.dtd.$empty[ el.getName() ] )
+					el = el[ isMoveToEnd ? 'getPrevious' : 'getNext' ]( nonWhitespaceOrBookmarkEval );
+				else
+					el = el[ isMoveToEnd ? 'getLast' : 'getFirst' ]( nonWhitespaceOrBookmarkEval );
+
+				// Stop immediately if we've found a text node.
+				if ( el && el.type == CKEDITOR.NODE_TEXT )
+				{
+					this.moveToPosition( el, isMoveToEnd ?
+					                         CKEDITOR.POSITION_AFTER_END :
+					                         CKEDITOR.POSITION_BEFORE_START );
+					return true;
+				}
+			}
+
+			return isEditable;
 		},
 
Index: CKEditor/branches/features/paste/_source/core/dom/walker.js
===================================================================
--- CKEditor/branches/features/paste/_source/core/dom/walker.js	(revision 4717)
+++ CKEditor/branches/features/paste/_source/core/dom/walker.js	(revision 4743)
@@ -48,5 +48,5 @@
 				return ( ( !movingOut || !limitLTR.equals( node ) )
 					&& ( !blockerLTR || !node.equals( blockerLTR ) )
-					&& ( node.type != CKEDITOR.NODE_ELEMENT || node.getName() != 'body' ) );
+					&& ( node.type != CKEDITOR.NODE_ELEMENT || !movingOut || node.getName() != 'body' ) );
 			};
 		}
@@ -63,5 +63,5 @@
 				return ( ( !movingOut || !limitRTL.equals( node ) )
 					&& ( !blockerRTL || !node.equals( blockerRTL ) )
-					&& ( node.type != CKEDITOR.NODE_ELEMENT || node.getName() != 'body' ) );
+					&& ( node.type != CKEDITOR.NODE_ELEMENT || !movingOut || node.getName() != 'body' ) );
 			};
 		}
@@ -79,5 +79,5 @@
 					return false;
 
-				return userGuard( node );
+				return userGuard( node, movingOut );
 			};
 		}
@@ -397,5 +397,5 @@
 
 	/**
-	 * Whether the node contains only white-spaces characters.
+	 * Whether the node is a text node containing only whitespaces characters.
 	 * @param isReject
 	 */
Index: CKEditor/branches/features/paste/_source/core/dtd.js
===================================================================
--- CKEditor/branches/features/paste/_source/core/dtd.js	(revision 4717)
+++ CKEditor/branches/features/paste/_source/core/dtd.js	(revision 4743)
@@ -1,3 +1,3 @@
-﻿/*
+﻿﻿/*
 Copyright (c) 2003-2009, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -91,4 +91,6 @@
 		$blockLimit : { body:1,div:1,td:1,th:1,caption:1,form:1 },
 
+		$inline : L,	// Just like span.
+		
 		$body : X({script:1,style:1}, block),
 
Index: CKEditor/branches/features/paste/_source/core/editor_basic.js
===================================================================
--- CKEditor/branches/features/paste/_source/core/editor_basic.js	(revision 4717)
+++ CKEditor/branches/features/paste/_source/core/editor_basic.js	(revision 4743)
@@ -132,14 +132,15 @@
 	CKEDITOR.editor.appendTo = function( elementOrId, config )
 	{
-		if ( typeof elementOrId != 'object' )
+		var element = elementOrId;
+		if ( typeof element != 'object' )
 		{
-			elementOrId = document.getElementById( elementOrId );
+			element = document.getElementById( elementOrId );
 
-			if ( !elementOrId )
+			if( !element )
 				throw '[CKEDITOR.editor.appendTo] The element with id "' + elementOrId + '" was not found.';
 		}
 
 		// Create the editor instance.
-		return new CKEDITOR.editor( config, elementOrId, CKEDITOR.ELEMENT_MODE_APPENDTO );
+		return new CKEDITOR.editor( config, element, CKEDITOR.ELEMENT_MODE_APPENDTO );
 	};
 
Index: CKEditor/branches/features/paste/_source/core/htmlparser/fragment.js
===================================================================
--- CKEditor/branches/features/paste/_source/core/htmlparser/fragment.js	(revision 4717)
+++ CKEditor/branches/features/paste/_source/core/htmlparser/fragment.js	(revision 4743)
@@ -299,5 +299,5 @@
 			{
 				// Add all elements that have been found in the above loop.
-				for ( var i = 0 ; i < pendingAdd.length ; i++ )
+				for ( i = 0 ; i < pendingAdd.length ; i++ )
 				{
 					var node = pendingAdd[ i ];
Index: CKEditor/branches/features/paste/_source/core/tools.js
===================================================================
--- CKEditor/branches/features/paste/_source/core/tools.js	(revision 4717)
+++ CKEditor/branches/features/paste/_source/core/tools.js	(revision 4743)
@@ -20,4 +20,20 @@
 	CKEDITOR.tools =
 	{
+		/**
+		 * Compare the elements of two arrays.
+		 * @param {Array} arrayA An array to be compared.
+		 * @param {Array} arrayB The other array to be compared.
+		 * @returns {Boolean} "true" is the arrays have the same lenght and
+		 *		their elements match.
+		 * @example
+		 * var a = [ 1, 'a', 3 ];
+		 * var b = [ 1, 3, 'a' ];
+		 * var c = [ 1, 'a', 3 ];
+		 * var d = [ 1, 'a', 3, 4 ];
+		 *
+		 * alert( CKEDITOR.tools.arrayCompare( a, b ) );  // false
+		 * alert( CKEDITOR.tools.arrayCompare( a, c ) );  // true
+		 * alert( CKEDITOR.tools.arrayCompare( a, d ) );  // false
+		 */
 		arrayCompare : function( arrayA, arrayB )
 		{
@@ -302,5 +318,5 @@
 		 * Ref: http://www.w3.org/TR/css3-selectors/#grammar
 		 * @param cssSelectText
-		 * @return the escaped selector text. 
+		 * @return the escaped selector text.
 		 */
 		escapeCssSelector : function( cssSelectText )
@@ -482,4 +498,22 @@
 				},
 
+		/**
+		 * Creates a function that will always execute in the context of a
+		 * specified object.
+		 * @param {Function} func The function to be executed.
+		 * @param {Object} obj The object to which bind the execution context.
+		 * @returns {Function} The function that can be used to execute the
+		 *		"func" function in the context of "obj".
+		 * @example
+		 * var obj = { text : 'My Object' };
+		 *
+		 * function alertText()
+		 * {
+		 *     alert( this.text );
+		 * }
+		 *
+		 * var newFunc = <b>CKEDITOR.tools.bind( alertText, obj )</b>;
+		 * newFunc();  // Alerts "My Object".
+		 */
 		bind : function( func, obj )
 		{
@@ -493,9 +527,9 @@
 		 * <li> Static fields </li>
 		 * <li> Private fields </li>
-		 * <li> Public(prototype) fields </li>
+		 * <li> Public (prototype) fields </li>
 		 * <li> Chainable base class constructor </li>
 		 * </ul>
-		 *
-		 * @param {Object} definiton (Optional)The class definiton object.
+		 * @param {Object} definiton The class definiton object.
+		 * @returns {Function} A class-like JavaScript function.
 		 */
 		createClass : function( definition )
@@ -550,4 +584,20 @@
 		},
 
+		/**
+		 * Creates a function reference that can be called later using
+		 * CKEDITOR.tools.callFunction. This approach is specially useful to
+		 * make DOM attribute function calls to JavaScript defined functions.
+		 * @param {Function} fn The function to be executed on call.
+		 * @param {Object} [scope] The object to have the context on "fn" execution.
+		 * @returns {Number} A unique reference to be used in conjuction with
+		 *		CKEDITOR.tools.callFunction.
+		 * @example
+		 * var ref = <b>CKEDITOR.tools.addFunction</b>(
+		 *     function()
+		 *     {
+		 *         alert( 'Hello!');
+		 *     });
+		 * CKEDITOR.tools.callFunction( ref );  // Hello!
+		 */
 		addFunction : function( fn, scope )
 		{
@@ -558,8 +608,24 @@
 		},
 
-		callFunction : function( index )
-		{
-			var fn = functions[ index ];
-			return fn.apply( window, Array.prototype.slice.call( arguments, 1 ) );
+		/**
+		 * Executes a function based on the reference created with
+		 * CKEDITOR.tools.addFunction.
+		 * @param {Number} ref The function reference created with
+		 *		CKEDITOR.tools.addFunction.
+		 * @param {[Any,[Any,...]} params Any number of parameters to be passed
+		 *		to the executed function.
+		 * @returns {Any} The return value of the function.
+		 * @example
+		 * var ref = CKEDITOR.tools.addFunction(
+		 *     function()
+		 *     {
+		 *         alert( 'Hello!');
+		 *     });
+		 * <b>CKEDITOR.tools.callFunction( ref )</b>;  // Hello!
+		 */
+		callFunction : function( ref )
+		{
+			var fn = functions[ ref ];
+			return fn && fn.apply( window, Array.prototype.slice.call( arguments, 1 ) );
 		},
 
